/* Battery.c generated by valac 0.56.14, the Vala compiler
 * generated from Battery.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://launchpad.net/switchboard-plug-power)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "power.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define POWER_TYPE_UPOWER (power_upower_get_type ())
#define POWER_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER, PowerUpower))
#define POWER_IS_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER))
#define POWER_UPOWER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER, PowerUpowerIface))

typedef struct _PowerUpower PowerUpower;
typedef struct _PowerUpowerIface PowerUpowerIface;

#define POWER_TYPE_UPOWER_PROXY (power_upower_proxy_get_type ())

#define POWER_TYPE_UPOWER_DEVICE (power_upower_device_get_type ())
#define POWER_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDevice))
#define POWER_IS_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER_DEVICE))
#define POWER_UPOWER_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDeviceIface))

typedef struct _PowerUpowerDevice PowerUpowerDevice;
typedef struct _PowerUpowerDeviceIface PowerUpowerDeviceIface;

#define POWER_TYPE_UPOWER_DEVICE_PROXY (power_upower_device_proxy_get_type ())
enum  {
	POWER_BATTERY_0_PROPERTY,
	POWER_BATTERY_NUM_PROPERTIES
};
static GParamSpec* power_battery_properties[POWER_BATTERY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerUpowerIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (PowerUpower* self, gint* result_length1, GError** error);
	gboolean (*get_on_battery) (PowerUpower* self);
	gboolean (*get_low_on_battery) (PowerUpower* self);
};

struct _PowerUpowerDeviceIface {
	GTypeInterface parent_iface;
	void (*refresh) (PowerUpowerDevice* self, GError** error);
	gboolean (*get_online) (PowerUpowerDevice* self);
	gboolean (*get_power_supply) (PowerUpowerDevice* self);
	gboolean (*get_is_present) (PowerUpowerDevice* self);
	guint (*get_device_type) (PowerUpowerDevice* self);
};

struct _PowerBatteryPrivate {
	PowerUpower* upower;
	PowerUpowerDevice* upower_device;
	gchar* dbus_upower_battery_path;
};

static gint PowerBattery_private_offset;
static gpointer power_battery_parent_class = NULL;

VALA_EXTERN GType power_upower_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN GType power_upower_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType power_upower_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_device_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType power_upower_device_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean power_upower_get_on_battery (PowerUpower* self);
VALA_EXTERN gboolean power_upower_device_get_is_present (PowerUpowerDevice* self);
static gchar* power_battery_get_dbus_path (PowerBattery* self,
                                    PowerUpower* upow);
VALA_EXTERN char** power_upower_enumerate_devices (PowerUpower* self,
                                       gint* result_length1,
                                       GError** error);
VALA_EXTERN guint power_upower_device_get_device_type (PowerUpowerDevice* self);
static GObject * power_battery_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void power_battery_finalize (GObject * obj);
static GType power_battery_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_battery_get_instance_private (PowerBattery* self)
{
	return G_STRUCT_MEMBER_P (self, PowerBattery_private_offset);
}

gboolean
power_battery_is_present (PowerBattery* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PowerUpower* _tmp2_;
	gboolean result;
#line 41 "../src/Battery.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/Battery.vala"
	_tmp2_ = self->priv->upower;
#line 42 "../src/Battery.vala"
	if (_tmp2_ != NULL) {
#line 135 "Battery.c"
		PowerUpower* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 42 "../src/Battery.vala"
		_tmp3_ = self->priv->upower;
#line 42 "../src/Battery.vala"
		_tmp4_ = power_upower_get_on_battery (_tmp3_);
#line 42 "../src/Battery.vala"
		_tmp5_ = _tmp4_;
#line 42 "../src/Battery.vala"
		_tmp1_ = _tmp5_;
#line 147 "Battery.c"
	} else {
#line 42 "../src/Battery.vala"
		_tmp1_ = FALSE;
#line 151 "Battery.c"
	}
#line 42 "../src/Battery.vala"
	if (_tmp1_) {
#line 42 "../src/Battery.vala"
		_tmp0_ = TRUE;
#line 157 "Battery.c"
	} else {
		gboolean _tmp6_ = FALSE;
		PowerUpowerDevice* _tmp7_;
#line 42 "../src/Battery.vala"
		_tmp7_ = self->priv->upower_device;
#line 42 "../src/Battery.vala"
		if (_tmp7_ != NULL) {
#line 165 "Battery.c"
			PowerUpowerDevice* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 42 "../src/Battery.vala"
			_tmp8_ = self->priv->upower_device;
#line 42 "../src/Battery.vala"
			_tmp9_ = power_upower_device_get_is_present (_tmp8_);
#line 42 "../src/Battery.vala"
			_tmp10_ = _tmp9_;
#line 42 "../src/Battery.vala"
			_tmp6_ = _tmp10_;
#line 177 "Battery.c"
		} else {
#line 42 "../src/Battery.vala"
			_tmp6_ = FALSE;
#line 181 "Battery.c"
		}
#line 42 "../src/Battery.vala"
		_tmp0_ = _tmp6_;
#line 185 "Battery.c"
	}
#line 42 "../src/Battery.vala"
	if (_tmp0_) {
#line 43 "../src/Battery.vala"
		result = TRUE;
#line 43 "../src/Battery.vala"
		return result;
#line 193 "Battery.c"
	}
#line 46 "../src/Battery.vala"
	result = FALSE;
#line 46 "../src/Battery.vala"
	return result;
#line 199 "Battery.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 212 "Battery.c"
}

static gchar*
power_battery_get_dbus_path (PowerBattery* self,
                             PowerUpower* upow)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 49 "../src/Battery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/Battery.vala"
	g_return_val_if_fail (upow != NULL, NULL);
#line 50 "../src/Battery.vala"
	_tmp0_ = g_strdup ("");
#line 50 "../src/Battery.vala"
	path = _tmp0_;
#line 231 "Battery.c"
	{
		char** devs = NULL;
		gint _tmp1_ = 0;
		char** _tmp2_;
		gint devs_length1;
		gint _devs_size_;
#line 52 "../src/Battery.vala"
		_tmp2_ = power_upower_enumerate_devices (upow, &_tmp1_, &_inner_error0_);
#line 52 "../src/Battery.vala"
		devs = _tmp2_;
#line 52 "../src/Battery.vala"
		devs_length1 = _tmp1_;
#line 52 "../src/Battery.vala"
		_devs_size_ = devs_length1;
#line 52 "../src/Battery.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "Battery.c"
			goto __catch0_g_error;
		}
		{
			gint i = 0;
#line 53 "../src/Battery.vala"
			i = 0;
#line 255 "Battery.c"
			{
				gboolean _tmp3_ = FALSE;
#line 53 "../src/Battery.vala"
				_tmp3_ = TRUE;
#line 53 "../src/Battery.vala"
				while (TRUE) {
#line 262 "Battery.c"
					char** _tmp5_;
					gint _tmp5__length1;
					PowerUpowerDevice* device = NULL;
					char** _tmp6_;
					gint _tmp6__length1;
					const char* _tmp7_;
					const gchar* _tmp8_;
					PowerUpowerDevice* _tmp9_;
					PowerUpowerDevice* _tmp10_;
					guint _tmp11_;
					guint _tmp12_;
#line 53 "../src/Battery.vala"
					if (!_tmp3_) {
#line 276 "Battery.c"
						gint _tmp4_;
#line 53 "../src/Battery.vala"
						_tmp4_ = i;
#line 53 "../src/Battery.vala"
						i = _tmp4_ + 1;
#line 282 "Battery.c"
					}
#line 53 "../src/Battery.vala"
					_tmp3_ = FALSE;
#line 53 "../src/Battery.vala"
					_tmp5_ = devs;
#line 53 "../src/Battery.vala"
					_tmp5__length1 = devs_length1;
#line 53 "../src/Battery.vala"
					if (!(i < _tmp5__length1)) {
#line 53 "../src/Battery.vala"
						break;
#line 294 "Battery.c"
					}
#line 54 "../src/Battery.vala"
					_tmp6_ = devs;
#line 54 "../src/Battery.vala"
					_tmp6__length1 = devs_length1;
#line 54 "../src/Battery.vala"
					_tmp7_ = _tmp6_[i];
#line 54 "../src/Battery.vala"
					_tmp8_ = string_to_string ((const gchar*) _tmp7_);
#line 54 "../src/Battery.vala"
					_tmp9_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp8_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 54 "../src/Battery.vala"
					device = (PowerUpowerDevice*) _tmp9_;
#line 54 "../src/Battery.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/Battery.vala"
						devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
#line 312 "Battery.c"
						goto __catch0_g_error;
					}
#line 56 "../src/Battery.vala"
					_tmp10_ = device;
#line 56 "../src/Battery.vala"
					_tmp11_ = power_upower_device_get_device_type (_tmp10_);
#line 56 "../src/Battery.vala"
					_tmp12_ = _tmp11_;
#line 56 "../src/Battery.vala"
					if (_tmp12_ == ((guint) 2)) {
#line 323 "Battery.c"
						char** _tmp13_;
						gint _tmp13__length1;
						const char* _tmp14_;
						const gchar* _tmp15_;
						gchar* _tmp16_;
#line 57 "../src/Battery.vala"
						_tmp13_ = devs;
#line 57 "../src/Battery.vala"
						_tmp13__length1 = devs_length1;
#line 57 "../src/Battery.vala"
						_tmp14_ = _tmp13_[i];
#line 57 "../src/Battery.vala"
						_tmp15_ = string_to_string ((const gchar*) _tmp14_);
#line 57 "../src/Battery.vala"
						_tmp16_ = g_strdup (_tmp15_);
#line 57 "../src/Battery.vala"
						_g_free0 (path);
#line 57 "../src/Battery.vala"
						path = _tmp16_;
#line 58 "../src/Battery.vala"
						_g_object_unref0 (device);
#line 58 "../src/Battery.vala"
						break;
#line 347 "Battery.c"
					}
#line 53 "../src/Battery.vala"
					_g_object_unref0 (device);
#line 351 "Battery.c"
				}
			}
		}
#line 51 "../src/Battery.vala"
		devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
#line 357 "Battery.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 51 "../src/Battery.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../src/Battery.vala"
		g_critical ("Battery.vala:62: acpi couldn't get upower devices");
#line 366 "Battery.c"
	}
	__finally0:
#line 51 "../src/Battery.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../src/Battery.vala"
		_g_free0 (path);
#line 51 "../src/Battery.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 51 "../src/Battery.vala"
		g_clear_error (&_inner_error0_);
#line 51 "../src/Battery.vala"
		return NULL;
#line 379 "Battery.c"
	}
#line 65 "../src/Battery.vala"
	result = path;
#line 65 "../src/Battery.vala"
	return result;
#line 385 "Battery.c"
}

PowerBattery*
power_battery_construct (GType object_type)
{
	PowerBattery * self = NULL;
#line 21 "../src/Battery.vala"
	self = (PowerBattery*) g_object_new (object_type, NULL);
#line 21 "../src/Battery.vala"
	return self;
#line 396 "Battery.c"
}

PowerBattery*
power_battery_new (void)
{
#line 21 "../src/Battery.vala"
	return power_battery_construct (POWER_TYPE_BATTERY);
#line 404 "Battery.c"
}

static GObject *
power_battery_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerBattery * self;
	GError* _inner_error0_ = NULL;
#line 27 "../src/Battery.vala"
	parent_class = G_OBJECT_CLASS (power_battery_parent_class);
#line 27 "../src/Battery.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../src/Battery.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_BATTERY, PowerBattery);
#line 422 "Battery.c"
	{
		PowerUpower* _tmp0_ = NULL;
		PowerUpower* _tmp1_;
		PowerUpower* _tmp2_;
		PowerUpower* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
#line 29 "../src/Battery.vala"
		_tmp1_ = (PowerUpower*) g_initable_new (POWER_TYPE_UPOWER_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_DBUS_UPOWER_PATH, "g-interface-name", "org.freedesktop.UPower", NULL);
#line 29 "../src/Battery.vala"
		_tmp0_ = (PowerUpower*) _tmp1_;
#line 29 "../src/Battery.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 437 "Battery.c"
			goto __catch0_g_error;
		}
#line 29 "../src/Battery.vala"
		_tmp2_ = _tmp0_;
#line 29 "../src/Battery.vala"
		_tmp0_ = NULL;
#line 29 "../src/Battery.vala"
		_g_object_unref0 (self->priv->upower);
#line 29 "../src/Battery.vala"
		self->priv->upower = _tmp2_;
#line 30 "../src/Battery.vala"
		_tmp3_ = self->priv->upower;
#line 30 "../src/Battery.vala"
		_tmp4_ = power_battery_get_dbus_path (self, _tmp3_);
#line 30 "../src/Battery.vala"
		_g_free0 (self->priv->dbus_upower_battery_path);
#line 30 "../src/Battery.vala"
		self->priv->dbus_upower_battery_path = _tmp4_;
#line 31 "../src/Battery.vala"
		_tmp6_ = self->priv->dbus_upower_battery_path;
#line 31 "../src/Battery.vala"
		if (g_strcmp0 (_tmp6_, "") != 0) {
#line 460 "Battery.c"
			const gchar* _tmp7_;
#line 31 "../src/Battery.vala"
			_tmp7_ = self->priv->dbus_upower_battery_path;
#line 31 "../src/Battery.vala"
			_tmp5_ = _tmp7_ != NULL;
#line 466 "Battery.c"
		} else {
#line 31 "../src/Battery.vala"
			_tmp5_ = FALSE;
#line 470 "Battery.c"
		}
#line 31 "../src/Battery.vala"
		if (_tmp5_) {
#line 474 "Battery.c"
			PowerUpowerDevice* _tmp8_ = NULL;
			const gchar* _tmp9_;
			PowerUpowerDevice* _tmp10_;
			PowerUpowerDevice* _tmp11_;
			const gchar* _tmp12_;
#line 32 "../src/Battery.vala"
			_tmp9_ = self->priv->dbus_upower_battery_path;
#line 32 "../src/Battery.vala"
			_tmp10_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp9_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 32 "../src/Battery.vala"
			_tmp8_ = (PowerUpowerDevice*) _tmp10_;
#line 32 "../src/Battery.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/Battery.vala"
				_g_object_unref0 (_tmp0_);
#line 490 "Battery.c"
				goto __catch0_g_error;
			}
#line 32 "../src/Battery.vala"
			_tmp11_ = _tmp8_;
#line 32 "../src/Battery.vala"
			_tmp8_ = NULL;
#line 32 "../src/Battery.vala"
			_g_object_unref0 (self->priv->upower_device);
#line 32 "../src/Battery.vala"
			self->priv->upower_device = _tmp11_;
#line 33 "../src/Battery.vala"
			g_debug ("Battery.vala:33: Connection to UPower bus established");
#line 34 "../src/Battery.vala"
			_tmp12_ = self->priv->dbus_upower_battery_path;
#line 34 "../src/Battery.vala"
			g_debug ("Battery.vala:34: Battery detected at path: %s", _tmp12_);
#line 31 "../src/Battery.vala"
			_g_object_unref0 (_tmp8_);
#line 509 "Battery.c"
		}
#line 28 "../src/Battery.vala"
		_g_object_unref0 (_tmp0_);
#line 513 "Battery.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 28 "../src/Battery.vala"
		e = _inner_error0_;
#line 28 "../src/Battery.vala"
		_inner_error0_ = NULL;
#line 37 "../src/Battery.vala"
		_tmp13_ = e;
#line 37 "../src/Battery.vala"
		_tmp14_ = _tmp13_->message;
#line 37 "../src/Battery.vala"
		g_critical ("Battery.vala:37: Connecting to UPower bus failed: %s", _tmp14_);
#line 28 "../src/Battery.vala"
		_g_error_free0 (e);
#line 533 "Battery.c"
	}
	__finally0:
#line 28 "../src/Battery.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28 "../src/Battery.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 28 "../src/Battery.vala"
		g_clear_error (&_inner_error0_);
#line 542 "Battery.c"
	}
#line 27 "../src/Battery.vala"
	return obj;
#line 546 "Battery.c"
}

static void
power_battery_class_init (PowerBatteryClass * klass,
                          gpointer klass_data)
{
#line 21 "../src/Battery.vala"
	power_battery_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Battery.vala"
	g_type_class_adjust_private_offset (klass, &PowerBattery_private_offset);
#line 21 "../src/Battery.vala"
	G_OBJECT_CLASS (klass)->constructor = power_battery_constructor;
#line 21 "../src/Battery.vala"
	G_OBJECT_CLASS (klass)->finalize = power_battery_finalize;
#line 561 "Battery.c"
}

static void
power_battery_instance_init (PowerBattery * self,
                             gpointer klass)
{
#line 21 "../src/Battery.vala"
	self->priv = power_battery_get_instance_private (self);
#line 570 "Battery.c"
}

static void
power_battery_finalize (GObject * obj)
{
	PowerBattery * self;
#line 21 "../src/Battery.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_BATTERY, PowerBattery);
#line 22 "../src/Battery.vala"
	_g_object_unref0 (self->priv->upower);
#line 23 "../src/Battery.vala"
	_g_object_unref0 (self->priv->upower_device);
#line 25 "../src/Battery.vala"
	_g_free0 (self->priv->dbus_upower_battery_path);
#line 21 "../src/Battery.vala"
	G_OBJECT_CLASS (power_battery_parent_class)->finalize (obj);
#line 587 "Battery.c"
}

static GType
power_battery_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerBatteryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_battery_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerBattery), 0, (GInstanceInitFunc) power_battery_instance_init, NULL };
	GType power_battery_type_id;
	power_battery_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerBattery", &g_define_type_info, 0);
	PowerBattery_private_offset = g_type_add_instance_private (power_battery_type_id, sizeof (PowerBatteryPrivate));
	return power_battery_type_id;
}

GType
power_battery_get_type (void)
{
	static volatile gsize power_battery_type_id__once = 0;
	if (g_once_init_enter (&power_battery_type_id__once)) {
		GType power_battery_type_id;
		power_battery_type_id = power_battery_get_type_once ();
		g_once_init_leave (&power_battery_type_id__once, power_battery_type_id);
	}
	return power_battery_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

