/* PowerSupply.c generated by valac 0.56.14, the Vala compiler
 * generated from PowerSupply.vala, do not modify */

/*
 * Copyright 2011-2022 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "power.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define POWER_POWER_SUPPLY_LINE_POWER_TYPE ((guint) 1)

#define POWER_TYPE_UPOWER (power_upower_get_type ())
#define POWER_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER, PowerUpower))
#define POWER_IS_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER))
#define POWER_UPOWER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER, PowerUpowerIface))

typedef struct _PowerUpower PowerUpower;
typedef struct _PowerUpowerIface PowerUpowerIface;

#define POWER_TYPE_UPOWER_PROXY (power_upower_proxy_get_type ())

#define POWER_TYPE_UPOWER_DEVICE (power_upower_device_get_type ())
#define POWER_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDevice))
#define POWER_IS_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER_DEVICE))
#define POWER_UPOWER_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDeviceIface))

typedef struct _PowerUpowerDevice PowerUpowerDevice;
typedef struct _PowerUpowerDeviceIface PowerUpowerDeviceIface;

#define POWER_TYPE_UPOWER_DEVICE_PROXY (power_upower_device_proxy_get_type ())
enum  {
	POWER_POWER_SUPPLY_0_PROPERTY,
	POWER_POWER_SUPPLY_NUM_PROPERTIES
};
static GParamSpec* power_power_supply_properties[POWER_POWER_SUPPLY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerUpowerIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (PowerUpower* self, gint* result_length1, GError** error);
	gboolean (*get_on_battery) (PowerUpower* self);
	gboolean (*get_low_on_battery) (PowerUpower* self);
};

struct _PowerUpowerDeviceIface {
	GTypeInterface parent_iface;
	void (*refresh) (PowerUpowerDevice* self, GError** error);
	gboolean (*get_online) (PowerUpowerDevice* self);
	gboolean (*get_power_supply) (PowerUpowerDevice* self);
	gboolean (*get_is_present) (PowerUpowerDevice* self);
	guint (*get_device_type) (PowerUpowerDevice* self);
};

struct _PowerPowerSupplyPrivate {
	PowerUpower* upower;
	PowerUpowerDevice* upower_device;
	gboolean dbus_upower_power_supply;
};

static gint PowerPowerSupply_private_offset;
static gpointer power_power_supply_parent_class = NULL;

VALA_EXTERN GType power_upower_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN GType power_upower_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType power_upower_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_device_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType power_upower_device_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void power_upower_device_refresh (PowerUpowerDevice* self,
                                  GError** error);
VALA_EXTERN gboolean power_upower_device_get_online (PowerUpowerDevice* self);
VALA_EXTERN gboolean power_upower_device_get_power_supply (PowerUpowerDevice* self);
static void power_power_supply_get_upower_ac_device (PowerPowerSupply* self,
                                              PowerUpower* upow);
VALA_EXTERN char** power_upower_enumerate_devices (PowerUpower* self,
                                       gint* result_length1,
                                       GError** error);
VALA_EXTERN guint power_upower_device_get_device_type (PowerUpowerDevice* self);
static GObject * power_power_supply_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void power_power_supply_finalize (GObject * obj);
static GType power_power_supply_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_power_supply_get_instance_private (PowerPowerSupply* self)
{
	return G_STRUCT_MEMBER_P (self, PowerPowerSupply_private_offset);
}

gboolean
power_power_supply_check_present (PowerPowerSupply* self)
{
	gboolean present = FALSE;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 35 "../src/PowerSupply.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/PowerSupply.vala"
	present = FALSE;
#line 37 "../src/PowerSupply.vala"
	if (self->priv->dbus_upower_power_supply) {
#line 138 "PowerSupply.c"
		PowerUpowerDevice* _tmp1_;
#line 37 "../src/PowerSupply.vala"
		_tmp1_ = self->priv->upower_device;
#line 37 "../src/PowerSupply.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 144 "PowerSupply.c"
	} else {
#line 37 "../src/PowerSupply.vala"
		_tmp0_ = FALSE;
#line 148 "PowerSupply.c"
	}
#line 37 "../src/PowerSupply.vala"
	if (_tmp0_) {
#line 152 "PowerSupply.c"
		{
			PowerUpowerDevice* _tmp2_;
			gboolean _tmp3_ = FALSE;
			PowerUpowerDevice* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 39 "../src/PowerSupply.vala"
			_tmp2_ = self->priv->upower_device;
#line 39 "../src/PowerSupply.vala"
			power_upower_device_refresh (_tmp2_, &_inner_error0_);
#line 39 "../src/PowerSupply.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "PowerSupply.c"
				goto __catch0_g_error;
			}
#line 41 "../src/PowerSupply.vala"
			_tmp4_ = self->priv->upower_device;
#line 41 "../src/PowerSupply.vala"
			_tmp5_ = power_upower_device_get_online (_tmp4_);
#line 41 "../src/PowerSupply.vala"
			_tmp6_ = _tmp5_;
#line 41 "../src/PowerSupply.vala"
			if (_tmp6_) {
#line 176 "PowerSupply.c"
				PowerUpowerDevice* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
#line 41 "../src/PowerSupply.vala"
				_tmp7_ = self->priv->upower_device;
#line 41 "../src/PowerSupply.vala"
				_tmp8_ = power_upower_device_get_power_supply (_tmp7_);
#line 41 "../src/PowerSupply.vala"
				_tmp9_ = _tmp8_;
#line 41 "../src/PowerSupply.vala"
				_tmp3_ = _tmp9_;
#line 188 "PowerSupply.c"
			} else {
#line 41 "../src/PowerSupply.vala"
				_tmp3_ = FALSE;
#line 192 "PowerSupply.c"
			}
#line 41 "../src/PowerSupply.vala"
			if (_tmp3_) {
#line 42 "../src/PowerSupply.vala"
				present = TRUE;
#line 198 "PowerSupply.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 38 "../src/PowerSupply.vala"
			e = _inner_error0_;
#line 38 "../src/PowerSupply.vala"
			_inner_error0_ = NULL;
#line 45 "../src/PowerSupply.vala"
			_tmp10_ = e;
#line 45 "../src/PowerSupply.vala"
			_tmp11_ = _tmp10_->message;
#line 45 "../src/PowerSupply.vala"
			g_warning ("PowerSupply.vala:45: Error recieved from upower: %s", _tmp11_);
#line 38 "../src/PowerSupply.vala"
			_g_error_free0 (e);
#line 219 "PowerSupply.c"
		}
		__finally0:
#line 38 "../src/PowerSupply.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "PowerSupply.c"
			gboolean _tmp12_ = FALSE;
#line 38 "../src/PowerSupply.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../src/PowerSupply.vala"
			g_clear_error (&_inner_error0_);
#line 38 "../src/PowerSupply.vala"
			return _tmp12_;
#line 232 "PowerSupply.c"
		}
	}
#line 49 "../src/PowerSupply.vala"
	result = present;
#line 49 "../src/PowerSupply.vala"
	return result;
#line 239 "PowerSupply.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/PowerSupply.vala"
	return self ? g_object_ref (self) : NULL;
#line 247 "PowerSupply.c"
}

static void
power_power_supply_get_upower_ac_device (PowerPowerSupply* self,
                                         PowerUpower* upow)
{
	GError* _inner_error0_ = NULL;
#line 52 "../src/PowerSupply.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/PowerSupply.vala"
	g_return_if_fail (upow != NULL);
#line 259 "PowerSupply.c"
	{
		char** devs = NULL;
		gint _tmp0_ = 0;
		char** _tmp1_;
		gint devs_length1;
		gint _devs_size_;
#line 54 "../src/PowerSupply.vala"
		_tmp1_ = power_upower_enumerate_devices (upow, &_tmp0_, &_inner_error0_);
#line 54 "../src/PowerSupply.vala"
		devs = _tmp1_;
#line 54 "../src/PowerSupply.vala"
		devs_length1 = _tmp0_;
#line 54 "../src/PowerSupply.vala"
		_devs_size_ = devs_length1;
#line 54 "../src/PowerSupply.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "PowerSupply.c"
			goto __catch0_g_error;
		}
		{
			gint i = 0;
#line 55 "../src/PowerSupply.vala"
			i = 0;
#line 283 "PowerSupply.c"
			{
				gboolean _tmp2_ = FALSE;
#line 55 "../src/PowerSupply.vala"
				_tmp2_ = TRUE;
#line 55 "../src/PowerSupply.vala"
				while (TRUE) {
#line 290 "PowerSupply.c"
					char** _tmp4_;
					gint _tmp4__length1;
					PowerUpowerDevice* dev = NULL;
					char** _tmp5_;
					gint _tmp5__length1;
					const char* _tmp6_;
					PowerUpowerDevice* _tmp7_;
					PowerUpowerDevice* _tmp8_;
					guint _tmp9_;
					guint _tmp10_;
#line 55 "../src/PowerSupply.vala"
					if (!_tmp2_) {
#line 303 "PowerSupply.c"
						gint _tmp3_;
#line 55 "../src/PowerSupply.vala"
						_tmp3_ = i;
#line 55 "../src/PowerSupply.vala"
						i = _tmp3_ + 1;
#line 309 "PowerSupply.c"
					}
#line 55 "../src/PowerSupply.vala"
					_tmp2_ = FALSE;
#line 55 "../src/PowerSupply.vala"
					_tmp4_ = devs;
#line 55 "../src/PowerSupply.vala"
					_tmp4__length1 = devs_length1;
#line 55 "../src/PowerSupply.vala"
					if (!(i < _tmp4__length1)) {
#line 55 "../src/PowerSupply.vala"
						break;
#line 321 "PowerSupply.c"
					}
#line 56 "../src/PowerSupply.vala"
					_tmp5_ = devs;
#line 56 "../src/PowerSupply.vala"
					_tmp5__length1 = devs_length1;
#line 56 "../src/PowerSupply.vala"
					_tmp6_ = _tmp5_[i];
#line 56 "../src/PowerSupply.vala"
					_tmp7_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _tmp6_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 56 "../src/PowerSupply.vala"
					dev = (PowerUpowerDevice*) _tmp7_;
#line 56 "../src/PowerSupply.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/PowerSupply.vala"
						devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
#line 337 "PowerSupply.c"
						goto __catch0_g_error;
					}
#line 57 "../src/PowerSupply.vala"
					_tmp8_ = dev;
#line 57 "../src/PowerSupply.vala"
					_tmp9_ = power_upower_device_get_device_type (_tmp8_);
#line 57 "../src/PowerSupply.vala"
					_tmp10_ = _tmp9_;
#line 57 "../src/PowerSupply.vala"
					if (_tmp10_ == POWER_POWER_SUPPLY_LINE_POWER_TYPE) {
#line 348 "PowerSupply.c"
						PowerUpowerDevice* _tmp11_;
						PowerUpowerDevice* _tmp12_;
#line 58 "../src/PowerSupply.vala"
						_tmp11_ = dev;
#line 58 "../src/PowerSupply.vala"
						_tmp12_ = _g_object_ref0 (_tmp11_);
#line 58 "../src/PowerSupply.vala"
						_g_object_unref0 (self->priv->upower_device);
#line 58 "../src/PowerSupply.vala"
						self->priv->upower_device = _tmp12_;
#line 59 "../src/PowerSupply.vala"
						self->priv->dbus_upower_power_supply = TRUE;
#line 60 "../src/PowerSupply.vala"
						_g_object_unref0 (dev);
#line 60 "../src/PowerSupply.vala"
						devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
#line 60 "../src/PowerSupply.vala"
						return;
#line 367 "PowerSupply.c"
					}
#line 55 "../src/PowerSupply.vala"
					_g_object_unref0 (dev);
#line 371 "PowerSupply.c"
				}
			}
		}
#line 53 "../src/PowerSupply.vala"
		devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
#line 377 "PowerSupply.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 53 "../src/PowerSupply.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/PowerSupply.vala"
		g_critical ("PowerSupply.vala:64: power supply couldn't get upower devices");
#line 386 "PowerSupply.c"
	}
	__finally0:
#line 53 "../src/PowerSupply.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/PowerSupply.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/PowerSupply.vala"
		g_clear_error (&_inner_error0_);
#line 53 "../src/PowerSupply.vala"
		return;
#line 397 "PowerSupply.c"
	}
}

PowerPowerSupply*
power_power_supply_construct (GType object_type)
{
	PowerPowerSupply * self = NULL;
#line 20 "../src/PowerSupply.vala"
	self = (PowerPowerSupply*) g_object_new (object_type, NULL);
#line 20 "../src/PowerSupply.vala"
	return self;
#line 409 "PowerSupply.c"
}

PowerPowerSupply*
power_power_supply_new (void)
{
#line 20 "../src/PowerSupply.vala"
	return power_power_supply_construct (POWER_TYPE_POWER_SUPPLY);
#line 417 "PowerSupply.c"
}

static GObject *
power_power_supply_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerPowerSupply * self;
	GError* _inner_error0_ = NULL;
#line 26 "../src/PowerSupply.vala"
	parent_class = G_OBJECT_CLASS (power_power_supply_parent_class);
#line 26 "../src/PowerSupply.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 26 "../src/PowerSupply.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_SUPPLY, PowerPowerSupply);
#line 435 "PowerSupply.c"
	{
		PowerUpower* _tmp0_ = NULL;
		PowerUpower* _tmp1_;
		PowerUpower* _tmp2_;
		PowerUpower* _tmp3_;
#line 28 "../src/PowerSupply.vala"
		_tmp1_ = (PowerUpower*) g_initable_new (POWER_TYPE_UPOWER_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_DBUS_UPOWER_PATH, "g-interface-name", "org.freedesktop.UPower", NULL);
#line 28 "../src/PowerSupply.vala"
		_tmp0_ = (PowerUpower*) _tmp1_;
#line 28 "../src/PowerSupply.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 447 "PowerSupply.c"
			goto __catch0_g_error;
		}
#line 28 "../src/PowerSupply.vala"
		_tmp2_ = _tmp0_;
#line 28 "../src/PowerSupply.vala"
		_tmp0_ = NULL;
#line 28 "../src/PowerSupply.vala"
		_g_object_unref0 (self->priv->upower);
#line 28 "../src/PowerSupply.vala"
		self->priv->upower = _tmp2_;
#line 29 "../src/PowerSupply.vala"
		_tmp3_ = self->priv->upower;
#line 29 "../src/PowerSupply.vala"
		power_power_supply_get_upower_ac_device (self, _tmp3_);
#line 27 "../src/PowerSupply.vala"
		_g_object_unref0 (_tmp0_);
#line 464 "PowerSupply.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 27 "../src/PowerSupply.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../src/PowerSupply.vala"
		g_critical ("PowerSupply.vala:31: power supply dbus connection to upower fault");
#line 473 "PowerSupply.c"
	}
	__finally0:
#line 27 "../src/PowerSupply.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "../src/PowerSupply.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "../src/PowerSupply.vala"
		g_clear_error (&_inner_error0_);
#line 482 "PowerSupply.c"
	}
#line 26 "../src/PowerSupply.vala"
	return obj;
#line 486 "PowerSupply.c"
}

static void
power_power_supply_class_init (PowerPowerSupplyClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/PowerSupply.vala"
	power_power_supply_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/PowerSupply.vala"
	g_type_class_adjust_private_offset (klass, &PowerPowerSupply_private_offset);
#line 20 "../src/PowerSupply.vala"
	G_OBJECT_CLASS (klass)->constructor = power_power_supply_constructor;
#line 20 "../src/PowerSupply.vala"
	G_OBJECT_CLASS (klass)->finalize = power_power_supply_finalize;
#line 501 "PowerSupply.c"
}

static void
power_power_supply_instance_init (PowerPowerSupply * self,
                                  gpointer klass)
{
#line 20 "../src/PowerSupply.vala"
	self->priv = power_power_supply_get_instance_private (self);
#line 24 "../src/PowerSupply.vala"
	self->priv->dbus_upower_power_supply = FALSE;
#line 512 "PowerSupply.c"
}

static void
power_power_supply_finalize (GObject * obj)
{
	PowerPowerSupply * self;
#line 20 "../src/PowerSupply.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_SUPPLY, PowerPowerSupply);
#line 21 "../src/PowerSupply.vala"
	_g_object_unref0 (self->priv->upower);
#line 22 "../src/PowerSupply.vala"
	_g_object_unref0 (self->priv->upower_device);
#line 20 "../src/PowerSupply.vala"
	G_OBJECT_CLASS (power_power_supply_parent_class)->finalize (obj);
#line 527 "PowerSupply.c"
}

static GType
power_power_supply_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerPowerSupplyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_power_supply_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerPowerSupply), 0, (GInstanceInitFunc) power_power_supply_instance_init, NULL };
	GType power_power_supply_type_id;
	power_power_supply_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerPowerSupply", &g_define_type_info, 0);
	PowerPowerSupply_private_offset = g_type_add_instance_private (power_power_supply_type_id, sizeof (PowerPowerSupplyPrivate));
	return power_power_supply_type_id;
}

GType
power_power_supply_get_type (void)
{
	static volatile gsize power_power_supply_type_id__once = 0;
	if (g_once_init_enter (&power_power_supply_type_id__once)) {
		GType power_power_supply_type_id;
		power_power_supply_type_id = power_power_supply_get_type_once ();
		g_once_init_leave (&power_power_supply_type_id__once, power_power_supply_type_id);
	}
	return power_power_supply_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

